#!/ysr/bin/env python
#-*- coding:utf-8 -*-
__author__ = "yua"

import boto3
from Service.Logger import logger

from Service.AWSSDK.AWSClient import AWSClient

class S3Client(AWSClient):
    def __init__(self, bucket_name):
        super().__init__()
        self.client = super().get_session().client('s3')
        self.s3 = boto3.resource('s3')
        self.bucket_name = bucket_name

    def search_s3_files(self, Prefix=''):
        try:
            response = self.client.list_objects_v2(Bucket=self.bucket_name, Prefix=Prefix)
            return response['Contents']
        except Exception as e:
            logger.error(str(e))
            return False

    def upload_file(self, local_path, remote_path):
        try:
            # self.s3.meta.client.upload_file(local_path, self.bucket_name, remote_path)
            self.client.upload_file(local_path, self.bucket_name, remote_path)
            return True
        except Exception as e:
            logger.error(str(e))
            return False

    def download_file(self, remote_path, local_path):
        try:
            self.client.download_file(self.bucket_name, remote_path, local_path)
            return True
        except Exception as e:
            logger.error(str(e))
            return False

    def set_tagging(self, key, set_tag_list):
        try:
            self.client.put_object_tagging(Bucket=self.bucket_name, Key=key, Tagging={'TagSet': set_tag_list})
            return True
        except Exception as e:
            logger.error(str(e))
            return False

    def get_tagging(self, key):
        try:
            response = self.client.get_object_tagging(Bucket=self.bucket_name, Key=key)
            return response['TagSet']
        except Exception as e:
            logger.error(str(e))
            return False