#!/ysr/bin/env python
#-*- coding:utf-8 -*-
__author__ = "yua"

import os, hashlib, zipfile, requests
from django.conf import settings
from Service.Logger import logger

class FileManage(object):
    def __init__(self, file_path):
        self.file_path = file_path

    def file_append(self, text):
        try:
            file_obj = open(self.file_path, 'a')
            file_obj.write(text)
            file_obj.flush()
            file_obj.close()
            return True
        except Exception as e:
            logger.error(str(e))
            return False

    def search_text_in_file(self, text):
        try:
            file_obj = open(self.file_path, 'r')
            if file_obj.read().find(text) != -1:
                file_obj.close()
                return True
            else:
                file_obj.close()
                return False
        except Exception as e:
            logger.error(str(e))
            return False

    def file_write_bin(self, bin_text):
        try:
            file_obj = open(self.file_path, 'wb')
            file_obj.write(bin_text)
            file_obj.flush()
            file_obj.close()
            return True
        except Exception as e:
            logger.error(str(e))
            return False

class FileMD5Check(object):
    def __init__(self, file_path):
        self.file_path = file_path

    def make_md5(self):
        packet_file_obj = open(self.file_path, 'rb')
        contents = packet_file_obj.read()
        packet_file_obj.close()
        file_md5 = hashlib.md5(contents).hexdigest()
        logger.info('【MD5校验】[%s]   md5值为:  %s' % (self.file_path, file_md5))

        return file_md5

    def check_files_md5(self, md5_file_path):
        # 传参md5文件
        if os.path.isfile(self.file_path):
            file_md5 = self.make_md5()

            md5_file_obj = open(md5_file_path, 'r')
            md5_number = md5_file_obj.read().replace('\n', '').replace(' ', '')
            logger.info('【MD5校验】[%s] md5为:  %s' % (md5_file_path, md5_number))

            if file_md5 == md5_number:
                logger.info('【MD5校验】md5校验成功!')
                return True
            else:
                logger.error('【MD5校验】md5校验失败!')
                return False
        else:
            logger.error('【MD5校验】MD5校验, 文件[%s]路径不存在!' % (self.file_path))
            return False

    def check_files_md5_str(self, md5_str):
        # 传参md5文件
        if os.path.isfile(self.file_path):
            file_md5 = self.make_md5()
            logger.info('【MD5校验】[参数]   md5值为:  %s' % (md5_str))

            if file_md5 == md5_str:
                logger.info('【MD5校验】md5校验成功!')
                return True
            else:
                logger.error('【MD5校验】md5校验失败!')
                return False
        else:
            logger.error('【MD5校验】MD5校验, 文件[%s]路径不存在!' % (self.file_path))
            return False

class FileZip(object):
    def __init__(self, file_path, file_base_dir='', file_mode='r'):
        self.file_path = file_path
        self.file_base_dir = file_base_dir
        self.file_mode = file_mode

    def unzip_file(self):
        if os.path.isfile(self.file_path):
            logger.info('【Zip操作】文件[%s]解压...' %(self.file_path))
            zip_file_obj = zipfile.ZipFile(self.file_path, self.file_mode)
            try:
                for file_name in zip_file_obj.namelist():
                    zip_file_obj.extract(file_name, os.path.dirname(self.file_path))
                return True
            except Exception as e:
                print(e)
                logger.error('【Zip操作】文件解压失败!')
        else:
            logger.error('【Zip操作】文件不存在!')
        return False

class GetHttpFile(object):
    def __init__(self, http_url):
        self.http_url = http_url

    def http_get_file(self, dict_file):
        """
        :param dict_file: {'project':'iap_service', 'file_name':'iap_service_1234', 'version': 1234, }
        :return: file_path
        """
        # try:
        logger.info('【HTTP GET文件】发送http请求.')
        obj_response = requests.get(self.http_url, params={'agent_key': settings.AGENT_KEY, 'file_info': str(dict_file)})
        print(obj_response.content)
        dict_response = eval(obj_response.content)

        if obj_response.status_code == 200:
            logger.info('【HTTP GET文件】接收文件.')
            obj_file = FileManage(os.path.join(settings.DATA_DIR, dict_file['file_name']))
            obj_file.file_write_bin(dict_response['file_bin'])

            logger.info('【HTTP GET文件】校验文件完整性.')
            obj_md5 = FileMD5Check(os.path.join(settings.DATA_DIR, dict_file['file_name']))
            if obj_md5.check_files_md5_str(dict_response['file_md5']):
                logger.info('【HTTP GET文件】GET文件[%s]成功.' %(dict_file['file_name']))
                return os.path.join(settings.DATA_DIR, dict_file['file_name'])
            else:
                logger.info('【HTTP GET文件】GET文件[%s]失败.' %(dict_file['file_name']))
                return False
        else:
            return False
            logger.info('【HTTP GET文件】HTTP状态异常[%s].' %(obj_response.status_code))
        # except Exception as e:
        #     logger.error('【HTTP GET文件】获取文件失败.')
        #     logger.error(e)
        #     return False
