#!/ysr/bin/env python
#-*- coding:utf-8 -*-
__author__ = "yua"

import logging, sys
from django.conf import settings
from DevopsAgent.Middleware.RequestIdMiddleware import RequestIDFilter

class CreateLogger(object):
    def __init__(self):
        logger = logging.getLogger('[Agent]')
        logger.setLevel(logging.INFO)
        logger.addFilter(RequestIDFilter())

        handler = logging.FileHandler(settings.LOG_FILE)
        handler.setLevel(logging.INFO)

        formatter = logging.Formatter("[%(asctime)s] [%(request_id)s] %(name)s [%(levelname)s]  %(message)s")

        handler.setFormatter(formatter)
        logger.addHandler(handler)

        self.logger = logger

    def info(self, msg):
        for line_info in msg.splitlines():
            self.logger.info('   '+line_info)
    def warning(self, msg):
        for line_info in msg.splitlines():
            self.logger.warning(line_info)
    def error(self, msg):
        for line_info in msg.splitlines():
            self.logger.error('  '+line_info)

logger = CreateLogger()